import 'package:oobium_datastore_gen/src/class_field.dart';
import 'package:oobium_datastore_gen/src/schema_parser.dart';
import 'package:xstring/xstring.dart';

class Class {

  final Schema schema;
  final String name;
  final bool singleton;
  final fields = <ClassField>[];

  Class({
    required this.schema,
    required this.name,
    this.singleton=false,
    Iterable<ClassField>? fields
  }) {
    fields?.forEach((f) => this.fields.add(f..parent = this));
  }

  late final String varName = name.varName;

  bool get isSingleton => singleton;
  bool get isNotSingleton => !isSingleton;

  bool get hasInitialState => fields.every((f) => f.isNullable || f.isInitialized);
  String get initialState => '$name._(${fields.map((f) => f.initializer ?? 'null').join(',')})';

  @override
  String toString() => name;
}
