import 'dart:io';

import 'package:dart_style/dart_style.dart';

String pluralize(String singular) {
  if(singular.endsWith('s')) return '${singular}es';
  if(singular.endsWith('y')) return '${singular.substring(0, singular.length - 1)}ies';
  return '${singular}s';
}

String read(File file) {
  return file.existsSync() ? file.readAsStringSync() : '';
}

List<String> readLines(File file) {
  return file.existsSync() ? file.readAsLinesSync() : const <String>[];
}

String tryFormat(String source) {
  try {
    return DartFormatter().format(source);
  } catch(e,s) {
    print('$e\n$s');
    return source;
  }
}

void write(String path, String source, {required bool overwrite}) {
  final file = File(path);
  if(overwrite || !file.existsSync()) {
    file.writeAsStringSync(tryFormat(source));
  }
}
